/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
fireform_trace(0,"fireform initiliaze...");
 
var fireform={
currentprof:new Array(),
options:{overwrite:false,onlyonce:false},
autofillprof:false,
initialized:false
}; //fireform;

fireform.supertrim = function(s) { return s.replace(/^\s+|\s+$/g, "") }

fireform.lookthisnoderev=function(no)
{ 
if (!no) return null;
var ret=null;
while (no)
{
if (no.nodeName=="INPUT" || no.nodeName=="SELECT" || no.nodeName=="DIV") return ret;
var found=fireform.lookthisnoderev(no.lastChild); //recurse
if (found) { if (ret) ret=found+" "+ret; else ret=found;}

if (no.nodeValue)
{ found=fireform.supertrim(no.nodeValue);
  if (found!="") { if (ret) ret=found+ret; else ret=found;}
}//if    
no=no.previousSibling;
}//while
return ret;

}//lookthisnoderev

fireform.guessfieldname=function(fi)
{ 
 var found=fireform.lookthisnoderev(fi.previousSibling);
 if (!found)
 { var no=fi.parentNode;
   while (!no.previousSibling) no=no.parentNode;
   no=no.previousSibling;
   while ( !found && (no))
   { found=fireform.lookthisnoderev(no.lastChild);
     no=no.previousSibling;
   }//while
 }//if
return found;         
} //guessfieldname

fireform.lookthisnodefwd=function(no)
{ 
if (!no) return null;
var ret=null;
if (no.nodeValue)
{ var found=fireform.supertrim(no.nodeValue);
  if (found!="") return found; // { if (ret) ret=ret+found; else ret=found;}
}//if 
while (no)
{
var found=fireform.lookthisnodefwd(no.firstChild); //recurse
if (found) return found;//{ if (ret) ret=ret+" "+found; else ret=found;}
no=no.nextSibling;
}//while
return ret;

}//lookthisnodefwd

fireform.guessbuttonname=function(fi)
{ 
  var found=fireform.lookthisnodefwd(fi.nextSibling);
  if(!found)
  { var no=fi.parentNode;
   while (!no.nextSibling) no=no.parentNode;
   no=no.nextSibling;
   while ( !found && (no))
   { found=fireform.lookthisnodefwd(no.firstChild);
     no=no.nextSibling;
   }//while
  }//if 
 //if (!found) found=fireform.lookthisnodefwd(fi.nextSibling);   
return found;         
} //guessbuttonname

fireform.display1field=function(fi)
{
if (fi.type=="radio" || fi.type=="checkbox") var guessedname=fireform.guessbuttonname(fi); 
else var guessedname=fireform.guessfieldname(fi); 
fi.setAttribute("style", "background-color:lightblue;");
fi.title="fireform : ["+fireform_getstring("fieldname")+"="+fi.name+"]";
if (fi.type=="radio" || fi.type=="checkbox") fi.title+="["+fireform_getstring("value")+"="+fi.value+"]";
fi.title+="["+fireform_getstring("guessed_name")+"="+guessedname+"]";
}// display1field

fireform.DisplayFields=function(win,depth)
{
var found=false;

var formElements = win.document.getElementsByTagName("select");
for (var i = 0; i < formElements.length; i++) 
     { fireform.display1field(formElements[i]);
       found=true;
  }//for i   
  
var formElements = win.document.getElementsByTagName("input");
for (var i = 0; i < formElements.length; i++) 
      {
	if (formElements[i].type=="text" || formElements[i].type=="password" || formElements[i].type == "radio" || formElements[i].type=="checkbox" || formElements[i].type=="file")
         { fireform.display1field(formElements[i]);
          found=true;
         } //if
      } //for

var formElements = win.document.getElementsByTagName("textarea");
for (var i = 0; i < formElements.length; i++) 
      {
       fireform.display1field(formElements[i]);
          found=true;
      } //for
            
// recurse
	var frames = win.document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++)
		if (this.DisplayFields(frames[i].contentWindow,depth+1)) found=true;
	var frames = win.document.getElementsByTagName("iframe");
	for (var i = 0; i < frames.length; i++) 
	    if (this.DisplayFields(frames[i].contentWindow,depth+1)) found=true;
if (depth==0)
{ if (found) 
    fireform_localert("dispfields");
  else fireform_localert("nodispfield");
}//if	

return found;
} // end DisplayFields

fireform.learn1field=function(prof,fi,last,url)
{

if ((fi.type=='radio') && !fi.checked) return last;

if (fi.tagName=="TEXTAREA") newval=escape(fi.value);
else newval=fi.value; 

fireform_save1line(prof,last,'desc',newval,fi.name,url);

return last+1;
	  
}// learn1field

fireform.LearnFields=function(win,depth)
{
var found=false;
var last=1;
var proftemp=999999; 
if (depth==0) fireform_prefs.deleteBranch("profiles.prof"+proftemp);

var cururl=window.content.location.toString();
var newurl=cururl;
var pos1=cururl.indexOf('//');
if (pos1>0) { var pos2=cururl.indexOf('/',pos1+2); if (pos2>0) newurl=cururl.substring(0,pos2);}
	
var formElements = win.document.getElementsByTagName("select");
for (var i = 0; i < formElements.length; i++) 
     { last=fireform.learn1field(proftemp,formElements[i],last,newurl);
       found=true;
  }//for i   
  
var formElements = win.document.getElementsByTagName("input");
for (var i = 0; i < formElements.length; i++) 
      {
	if (formElements[i].type=="text" || formElements[i].type=="password" || formElements[i].type == "radio" || formElements[i].type=="checkbox" || formElements[i].type=="file")
         { last=fireform.learn1field(proftemp,formElements[i],last,newurl);
          found=true;
         } //if
      } //for

var formElements = win.document.getElementsByTagName("textarea");
for (var i = 0; i < formElements.length; i++) 
      {
       last=fireform.learn1field(proftemp,formElements[i],last,newurl);
          found=true;
      } //for
            
// recurse
	var frames = win.document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++)
		if (this.LearnFields(frames[i].contentWindow,depth+1)) found=true;
	var frames = win.document.getElementsByTagName("iframe");
	for (var i = 0; i < frames.length; i++) 
	    if (this.LearnFields(frames[i].contentWindow,depth+1)) found=true;
	    
if (depth==0)
{ if (found)     
    window.openDialog("chrome://fireform/content/learnfields.xul", "&fireform-menu-options;", "chrome,resizable=yes");     
  else fireform_localert("nodispfield");
}//if	

return found;
} // end LearnFields

fireform.contextPopupShowing=function(event)
{ // display the context menu when right click on an input field

fireform.removemenu=function(menu)
{
// any way to do it better?
var nextitem=menu.firstChild;
while (nextitem) {
	var item=nextitem;nextitem=nextitem.nextSibling;
	if (item.nodeName=="menu") fireform.removemenu(item.firstChild);
	if (item.getAttribute("fireform-delete")=="1") menu.removeChild(item);
}//while	
}//removemenu

fireform.subpopup=function(menu)
{
var menuitem = document.getElementById(menu);
menuitem.hidden=true;
var tag=gContextMenu.target.tagName;

var submenu=document.getElementById(menu+"-popup");
var subothers=document.getElementById(menu+"-popupothers");
fireform.removemenu(submenu); //remove previous menu

var inputzonef=(tag=="INPUT" || tag=="SELECT" || tag=="TEXTAREA");
if (inputzonef)
{ 
	var displayed=Array();	
    var matchvalue=fireform.matchfield(gContextMenu.target,window.content.location.toString(),false);
    for ( var j in fireform.currentprof)
    { var desc=fireform.currentprof[j].desc;
      var value=fireform.currentprof[j].value;        
    
      if (desc!="")
      { 
        if (!displayed[desc])
        { displayed[desc]=true;
          var subitem=document.createElement("menuitem");
          subitem.setAttribute("label",fireform.currentprof[j].desc+" ("+value+")");
          subitem.setAttribute("fireform-delete","1");
          if (menu=="fireform-learn") //ahem...
			subitem.setAttribute("oncommand","fireform.learnas("+j+")");
          else
			subitem.setAttribute("oncommand","gContextMenu.target.value=unescape('"+escape(value)+"')");
		  if (value==matchvalue) subitem.setAttribute("style","font-weight:bold"); // fireform could fill this field
		  if (value!="") 
		     submenu.insertBefore(subitem,submenu.lastChild);
	      else if (subothers)
	        subothers.appendChild(subitem);   
	    }//if displayed 
	 }   
    }//for 
if (inputzonef)    
if (menu=="fireform-learn") //ahem...
  {
  document.getElementById(menu+"-others").hidden=!subothers.firstChild; // show others menu if non empty
  var subitem=document.createElement("menuitem"); //new field option
  subitem.setAttribute("fireform-delete","1");
  var menulabel=document.getElementById("fireform-strings").getString("create_field_title");
  subitem.setAttribute("label","<"+menulabel+">");
  subitem.setAttribute("oncommand","fireform.learnas(0)");
  submenu.appendChild(subitem);
  }
menuitem.hidden=!subitem;

}//inputzonef
}//subpopup

if (fireform_prefs.prefHasUserValue("currentprofile")) currentprofile=fireform_prefs.getCharPref("currentprofile");
	else return;
fireform_load1prof(fireform.currentprof,currentprofile);
fireform.subpopup("fireform-learn");
fireform.subpopup("fireform-fill");

} //contextpopupshowing


fireform.learnas=function(currentline)
{ 

if (fireform_prefs.prefHasUserValue("currentprofile")) currentprofile=fireform_prefs.getCharPref("currentprofile");
	else return;

var cururl=window.content.location.toString();
var newurl=cururl;
var pos1=cururl.indexOf('//');
if (pos1>0) { var pos2=cururl.indexOf('/',pos1+2); if (pos2>0) newurl=cururl.substring(0,pos2);}

var newtrig=gContextMenu.target.name;	

	fireform_load1prof(fireform.currentprof,currentprofile);
	var url="";
	for(var i in fireform.currentprof)
	   if ((";"+this.currentprof[i].trigger+";").indexOf(";"+newtrig+";")>=0) url=newurl;// trigger already known, add for this siteonly
	var last=1;
	while (fireform_prefs.prefHasUserValue("profiles.prof"+currentprofile+".field"+last+".desc")) last++; //look for empty line
	if (currentline>0)
	{
	var newval=fireform.currentprof[currentline].value;
	if (newval=="") // no value for this field in current profile
	{ var doc=document.getElementById("fireform-strings");
	  var check = {value: false};
	  var newvalue={value: ""};
	  if (gContextMenu.target.tagName=="TEXTAREA") newvalue.value=escape(gContextMenu.target.value);
	  else newvalue.value=gContextMenu.target.value;
	  if (!fireform_prompts.prompt(window, doc.getString("create_field_title"), doc.getString("ask_field_value"), newvalue, null, check)) return;
	  newval=newvalue.value;
	  last=currentline; // to overwrite current values
	}
	fireform_save1line(currentprofile,last,fireform.currentprof[currentline].desc,newval,newtrig,url);
	}
	else // create new field
	{ 
	  if (gContextMenu.target.tagName=="TEXTAREA") newval=escape(gContextMenu.target.value);
	  else newval=gContextMenu.target.value;
	  var doc=document.getElementById("fireform-strings");
	  var check = {value: false};
	  var newvalue={value: newval};
	  if (!fireform_prompts.prompt(window, doc.getString("create_field_title"), doc.getString("ask_field_value"), newvalue, null, check)) return;
	  newval=newvalue.value;
	  fireform_save1line(currentprofile,last,newtrig,newval,newtrig,url);
	}
	gContextMenu.target.value=unescape(newval);
}//learnas

fireform.match1field=function(name,currenturl,strictmatch)
{
var match=1000;
	var newvalue=null;
	for(var j in this.currentprof)
	{ 
	var urlfound=false; 
	if (this.currentprof[j].url!="") // check url
	{  
	   var urlist=this.currentprof[j].url.toLowerCase().split(";");
	   for (var u in urlist)
	         if (currenturl.toLowerCase().indexOf(urlist[u])==0) {urlfound=true; break;}
	   if (!urlfound) continue;
	} // check url   
	var strict=strictmatch || (this.currentprof[j].desc.toLowerCase().indexOf("(strictmatch)")>=0);
	if (strict)
	{ var testname=';'+name+';';
	  var testval=";"+this.currentprof[j].trigger.toLowerCase()+";";
	  if (testval.indexOf(testname)>=0) return j;// this.currentprof[j].value+''; //always string
	}
	else
	{ 
	  var s2=this.currentprof[j].trigger.toLowerCase().split(";")
	  for(var p in s2)
	  {
       if (s2[p].length>0)
	   if (name.indexOf(s2[p])>=0) { 
 				if ( ((name.length-s2[p].length)<match) // found
 				   || ( urlfound && ((name.length-s2[p].length)==match) ) )
				{match=name.length-s2[p].length;
				newvalue=j; //this.currentprof[j].value+''; //always string
				} //if
				} //if
     } // for p
   }//else  
} //for j
return newvalue; 
}//match1field

fireform.matchfield=function(fi,currenturl,strictmatch)
{
var ret=fireform.match1field(fi.name.toLowerCase(),currenturl,strictmatch); //try with real field name
if ((ret!=null) || strictmatch) 
 { if (this.options.onlyonce && (fi.type!="button") && (fi.type!="radio")) this.currentprof[ret].trigger='';
  return this.currentprof[ret].value+''; //always string
  }
// then try with guessed name
if (fi.type=="button" || fi.type=="checkbox") var gname=fireform.guessbuttonname(fi); else var gname=fireform.guessfieldname(fi);
if (gname) { ret=fireform.match1field(gname.replace(" ","").toLowerCase(),currenturl);
             if (ret)
               { if (this.options.onlyonce) this.currentprof[ret].trigger='';
                 return this.currentprof[ret].value+''; //always string
               }
            }
return null;
//this.options.overwrite
}//matchfield

fireform.Fillhttp=function(field, requrl,insert,clipboard)
{
var doc=document.getElementById("fireform-strings");

var request = new XMLHttpRequest();
request.open("GET", requrl, true); 
request.onreadystatechange = 
 function (aEvt) {
  if (request.readyState == 4) {
     if(request.status == 200)
     {
       if (requrl.indexOf("http://pastebin.ws")==0)
       { // retrieve content box
		var parser=new DOMParser();
		var resultDoc=parser.parseFromString(request.responseText,"text/xml");
		// test epic fail
		var resultTxt=resultDoc.getElementById("contentbox").value;
		if (clipboard)
		  { fireform.cclip(resultTxt);
		    fireform_localert("pastetoclipboard");
		    return} 
		if (insert)
		   field.value=field.value.substring(0,field.selectionStart)+resultTxt+field.value.substring(field.selectionEnd);
		else
          field.value=resultTxt;
       }
       else
       {
       field.value=request.responseText;
       field.focus();
       field.blur(); //simulate human input
       }
     }  
     else
      alert("Error reading "+requrl);
  }//if
  }//function

request.send(null); 

}//fillhttp


fireform.cclip=function(copytext)
{//copy to clipboard

var str   = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
if (!str) return false;

str.data  = copytext;

var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
if (!trans) return false;

trans.addDataFlavor("text/unicode");
trans.setTransferData("text/unicode", str, copytext.length * 2);

var clipid = Components.interfaces.nsIClipboard;
var clip   = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
if (!clip) return false;

clip.setData(trans, null, clipid.kGlobalClipboard);
}//cclip


fireform.FillFields=function(win,depth,profname,nomsg,strictmatch)
{ 
if (!fireform_prefs.prefHasUserValue("currentprofile")) // first run
{
fireform_prefs.setCharPref("currentprofile",0);
fireform_trace(0,"fireform welcome message");    
fireform_localert("welcome");
window.open("chrome://fireform/content/simplesetup.xul", "", "chrome,resizable=yes,alwaysRaised=true");
return false;
}//if

var found=false;
if (depth==0)
 { var currentprofile=0;
  if (fireform_prefs.prefHasUserValue("currentprofile")) currentprofile=fireform_prefs.getCharPref("currentprofile");
  if (currentprofile<=0) { fireform_localert("noprofile"); return found;}

if (profname!="") selectprof=profname;
if (selectprof) // choose the right profile
{ var testprof=1;
  var foundprof=false;
  while (fireform_prefs.prefHasUserValue("profiles.prof"+testprof+".name"))
  {   if (fireform_prefs.getCharPref("profiles.prof"+testprof+".name").toLowerCase()==selectprof.toLowerCase())
      { currentprofile=testprof; break; }     
   testprof++;  
  }  
}//selectprof
fireform_load1prof(this.currentprof,currentprofile);
fireform_load_options(this.options);
    
var curprofname=fireform_prefs.getCharPref("profiles.prof"+currentprofile+".name")
if (curprofname.toLowerCase()=="fakenamegenerator") fireform.getfake(curprofname); // get a fake profile each time
    
//look for temporary triggers
//https?
//if (win.location.protocol!="https:")
{
var params = win.location.search.substring(1).split("&");
var newtrig,newval,newurl;
var selectprof=false;
newtrig=newval=newurl=null;
for (var i in params) {
   var onevar = params[i].split("=");
   if (onevar[0]=="fireform-trig") newtrig=unescape(onevar[1]);
   if (onevar[0]=="fireform-val") newval=decodeURIComponent(onevar[1]);
   if (onevar[0]=="fireform-url") newurl=unescape(onevar[1]);
   if (onevar[0]=="fireform-prof") selectprof=unescape(onevar[1]);
   if (newtrig && newval) 
      { if (newurl==null) newurl="";
        this.currentprof[this.currentprof.length]=new fireform_profile("fireform-temp (strictmatch)",newval,newtrig,newurl);
        newval=newtrig=newurl=null;
      }  //if
} //for
} //https

}//if depth

var formElements = win.document.getElementsByTagName("select");
     for (var i = 0; i < formElements.length; i++) 
		{ var newvalue=fireform.matchfield(formElements[i],win.location.toString(),strictmatch);
		  var foundb=false;
		  if (newvalue) //found
			{
				var s2=newvalue.toLowerCase().split(";");
				// exact match
				for (var j = 0; j < formElements[i].options.length && !foundb; j++) 
				{
			     for(var p in s2)
			       if (formElements[i].options[j].text.toLowerCase()==s2[p]) 
			       {formElements[i].selectedIndex=j;
			        formElements[i].setAttribute("style", "background-color:lightgreen;");
			        found=foundb=true;
			        break;
			       } //if
				} //for j

				// loose (substring) match for select's options
				if (!foundb)
					for (var j = 0; j < formElements[i].options.length && !foundb; j++) 
					{
				     for(var p in s2)
				       if (formElements[i].options[j].text.toLowerCase().indexOf(s2[p]) >=0 ) 
				       {formElements[i].selectedIndex=j;
				        formElements[i].setAttribute("style", "background-color:lightgreen;");
				        found=foundb=true;
				        break;
				       } //if
					} //for j

			} //if
		  		  
		} //for i  

var exactmatch=Array();		
var formElements = win.document.getElementsByTagName("input");
      for (var i = 0; i < formElements.length; i++) 
      { 
      if (formElements[i].type=="text" || formElements[i].type=="password" || formElements[i].type=="file")
	    { // try to fill in
	  
			var newvalue=fireform.matchfield(formElements[i],win.location.toString(),strictmatch);
			if (newvalue) // found
			{ 	
				if (this.options.overwrite || (formElements[i].value=="")) // take care of overwrite
				{
			    formElements[i].setAttribute("style", "background-color:lightgreen;");
			    var fillvalue=newvalue.split(";")[0];  
			    // ------------ http request
			    if ((fillvalue.indexOf("=http:"))==0) 
   		           fireform.Fillhttp(formElements[i],fillvalue.substring(1));  
			    // ------------ end http request
			    else formElements[i].value=fillvalue;
			    }
				found=true;
			}       // if match
         } //if
           
        if ( formElements[i].type == "radio" || formElements[i].type =="checkbox" )
        { var newvalue=fireform.matchfield(formElements[i],win.location.toString(),strictmatch);
          if (newvalue) // found
          { var s2=newvalue.replace(/\s/g,"").toLowerCase().split(";")
            var gbname=formElements[i].value;
            var foundb=false;
            if (gbname)
			{ gbname=gbname.replace(/\s/g,"").toLowerCase();
				// exact match
	            for (var p in s2)
			    {  if (s2[p]==gbname) //found
				   {formElements[i].setAttribute("style", "background-color:lightgreen;");
				    if (newvalue=='off' || newvalue==0 || newvalue=='uncheck') formElements[i].checked=false;
					else formElements[i].checked=true;
					exactmatch[formElements[i].name]=true;
					break;
				   }  // if s2[p]
				}// for p in s2
				if (exactmatch[formElements[i].name]) found=foundb=true;
				if (!foundb)
				{
					// substring match
		            for (var p in s2)
				    {  if (gbname.indexOf(s2[p]) >= 0) //found
					   {formElements[i].setAttribute("style", "background-color:lightgreen;");
					   if (newvalue=='off' || newvalue==0 || newvalue=='uncheck') formElements[i].checked=false;
						else formElements[i].checked=true;
						found=foundb=true;
						break;
					   }  // if s2[p]
					}// for p in s2
				} // !foundb

			} // if gbname

			if (!foundb)
			{ 
            var gbname1=fireform.guessbuttonname(formElements[i]);
            if (gbname1)
				{ gbname1=gbname1.replace(/\s/g,"").toLowerCase();
				  for (var p in s2)
		             if (s2[p]==gbname1) //found
					   {formElements[i].setAttribute("style", "background-color:lightgreen;");
						formElements[i].checked=true;
						found=foundb=true;
						break;
					  }//if s2[p]

					if (!foundb)
					{
						// substring match
			            for (var p in s2)
					    {  if (gbname1.indexOf(s2[p]) >= 0) //found
						   {formElements[i].setAttribute("style", "background-color:lightgreen;");
							formElements[i].checked=true;
							found=foundb=true;
							break;
						   }  // if s2[p]
						}// for p in s2
					} // !foundb
				} //if gbname1
			} //foundb  
 

         }//if newvalue
        }//if type
       } // for i  

var formElements = win.document.getElementsByTagName("textarea");
for (var i = 0; i < formElements.length; i++) 
	   {var newvalue=fireform.matchfield(formElements[i],win.location.toString(),strictmatch);
		 if (newvalue) // found
			{ 	
				if (this.options.overwrite || (formElements[i].value=="")) // take care of overwrite
				{
				formElements[i].setAttribute("style", "background-color:lightgreen;");
			    //formElements[i].value=newvalue.split(";")[0];
			    var fillvalue=newvalue;
			    // ------------ http request
			    if ((fillvalue.indexOf("=http:"))==0) 
   		           fireform.Fillhttp(formElements[i],fillvalue.substring(1));
			    // ------------ end http request
			    else formElements[i].value=unescape(fillvalue);
			    }
				found=true;
			}       // if match
       } // for
       
// recurse
	var frames = win.document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++)
		if (this.FillFields(frames[i].contentWindow,depth+1,nomsg,strictmatch)) found=true;
	var frames = win.document.getElementsByTagName("iframe");
	for (var i = 0; i < frames.length; i++)
		if (this.FillFields(frames[i].contentWindow,depth+1,nomsg,strictmatch)) found=true;
		
if ((depth==0) && !found && !nomsg) fireform_localert("unable");
return found;
	
} // end FillFields

fireform.select=function(num)
{
fireform_prefs.setCharPref("currentprofile",num);
} //select

fireform.menupopup=function(button)
{
// creates the fireform menu popup
if (fireform_prefs.prefHasUserValue("currentprofile")) 
{
var liste=button.childNodes;
for(var n=1;liste.item(n).nodeName!="menuseparator";n++);
while (liste.length>n+1) button.removeChild(liste.item(n+1)); //remove old menu

var currentprofile=fireform_prefs.getCharPref("currentprofile");
var i=1;
while (fireform_prefs.prefHasUserValue("profiles.prof"+i+".name"))
{var name=fireform_prefs.getCharPref("profiles.prof"+i+".name");
if (fireform_prefs.prefHasUserValue("profiles.prof"+i+".shortkey"))
  name+=" (ctrl "+fireform_prefs.getCharPref("profiles.prof"+i+".shortkey")+")";
var menu=document.createElement("menuitem");menu.id="prof"+i;menu.setAttribute("label",name);
if (i==currentprofile) menu.setAttribute("style","font-weight:bold");
menu.setAttribute("oncommand","fireform.select("+i+")");
button.appendChild(menu);
i++;
}//while
}//if

return true;
}//menupopup

fireform.delete_all=function()
{ // should be called when uninstalling...
var prefsall= Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.");
prefsall.deleteBranch("fireform");
}

var myObserver = {
    observe : function ( subject , topic , data ){
    if (topic == "em-action-requested") {
		subject.QueryInterface(Components.interfaces.nsIUpdateItem);
		if (subject.id == "fireform@mozilla.org") {
		  if (data=="item-uninstalled") fireform.delete_all() // remove all keys
        }
    }       
  }
 }  //myObserver

//initialisation
var ObserverServ = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
ObserverServ.addObserver ( myObserver , "em-action-requested" , false );

fireform.showupdatepage=function()
{ //open the update page in a new tab
try  { var generalprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.");
          var locale=generalprefs.getCharPref("useragent.locale"); }
catch (ex)  { locale="en";}
if (!(locale=="fr")) locale="en"; //french only currently...
var updateurl="http://fireform.free.fr/updates/"+locale+"/07_update.html"; 
getBrowser().selectedTab=getBrowser().addTab(updateurl);
}

fireform.updated=function()
{ //called on extension update
   setTimeout(function() {fireform.showupdatepage()},2000); //don't open the tab too early, or it will disappear
}

var ffversion="0.0";
if (fireform_prefs.prefHasUserValue("fireformversion")) ffversion=fireform_prefs.getCharPref("fireformversion");
if (ffversion != "0.7") // fireform was installed or updated - open updatepage
  { 
   fireform_prefs.setCharPref("fireformversion", "0.7");
   if (fireform_prefs.getCharPref("fireformversion")=="0.7") // check if update value has been written (protection like zonealarm force field)
      window.addEventListener("load", fireform.updated,false);
   else {/*should msg warning*/}      
   }

fireform.shortkeys=function()
{
// create all shorkeys

var keyset=document.getElementById("mainKeyset");
var i=1;
var first=keyset.firstChild;
while (fireform_prefs.prefHasUserValue("profiles.prof"+i+".name"))
{
if (fireform_prefs.prefHasUserValue("profiles.prof"+i+".shortkey"))
	{var profname=fireform_prefs.getCharPref("profiles.prof"+i+".name");
	var sk=fireform_prefs.getCharPref("profiles.prof"+i+".shortkey");
	var key=document.createElement("key");key.id="key_fireform_"+i;
	key.setAttribute("modifiers","accel");
    key.setAttribute("key",sk);
	key.setAttribute("oncommand","fireform.FillFields(window.content,0,'"+profname+"')",false,false);
	keyset.insertBefore(key,first); // to overwrite existing keys?
	}
i++;
}//while

}//shortkeys

fireform.importhttp=function(request,fakeprofname)
{
var fakeprof={
profs:new Array(),
profsnames:new Array(),
shortkeys:new Array()
};

var parser=new DOMParser();
var xmldoc=parser.parseFromString(request.responseText,"text/xml");

fireform_importxml(fakeprof,xmldoc);
// save the fake profile
var nbprofs=1;
while (fireform_prefs.prefHasUserValue("profiles.prof"+nbprofs+".name")) 
  { if (fakeprofname)
      if (fireform_prefs.getCharPref("profiles.prof"+nbprofs+".name")==fakeprofname) break;
    nbprofs++;
  }
fireform_prefs.deleteBranch("profiles.prof"+nbprofs+".field"); //delete old values if exist

if (!fakeprofname) fireform_prefs.setCharPref("profiles.prof"+nbprofs+".name",fakeprof.profsnames[1]);
var cp=fakeprof.profs[1];
for (var j in cp) 
  fireform_save1line(nbprofs,j,cp[j].desc,cp[j].value,cp[j].trigger,cp[j].url);
fireform_prefs.setCharPref("currentprofile",nbprofs);
}  //importhttp

fireform.getfake=function(fakeprofname)
{

fireform_load_options(this.options);
var requrl="http://www.fakenamegenerator.com/ff.php?c="+this.options.fgcountry+"&n="+this.options.fglanguage;
if (this.options.fggender=="1") requrl+="&gen=male";
if (this.options.fggender=="2") requrl+="&gen=female";

var request = new XMLHttpRequest();
request.open("GET", requrl, true); 
request.onreadystatechange = 
 function (aEvt) {
  if (request.readyState == 4) {
     if(request.status == 200)
      { if(!fakeprofname) fireform_localert("getafakeprofile");
       fireform.importhttp(request,fakeprofname);
      } 
     else
      alert("Error contacting FakeNameGenerator!");
  }//if
  }//function

request.send(null); 

}//getfake


fireform.onLoad=function(event)
{
//any better way to detect page load only once?
if (fireform.initialized) return;
fireform.initialized=true;
fireform.shortkeys();
var menu = document.getElementById("contentAreaContextMenu");
menu.addEventListener("popupshowing", function(e) { if (e.target.id.indexOf("fireform-")==0) return;fireform.contextPopupShowing(e)}, false);
}

fireform.init=function()
{
var appcontent = document.getElementById("appcontent");   // navigateur
if(appcontent) appcontent.addEventListener("load", fireform.onLoad, true);
}

window.addEventListener("load", function() {fireform.init(); }, false);

fireform.openfill=function(xml)
{
var doc =document.getElementById("fireform-strings");

var root = xml.getElementsByTagName('site');
if (root.length==0) fireform_localert("nourlfound");
for (var i =0;i<root.length;i++)
   {
   var p=root.item(i);
   myurl=p.getAttribute('value');
   if (myurl.substring(0,1)=='=') // indirection
      fireform.indirectList(myurl.substring(1));
   else   
     {  getBrowser().selectedTab=getBrowser().addTab(myurl);
   
      var browser = getBrowser().getBrowserForTab(getBrowser().selectedTab);
      browser.addEventListener("DOMContentLoaded", fireform.autofill, false);
      if (p.hasAttribute('wait')) browser.setAttribute('fireform_wait',p.getAttribute('wait'));
      if (p.hasAttribute('waitonpassword')) browser.setAttribute('fireform_waitonpassword',p.getAttribute('waitonpassword'));
      if (p.hasAttribute('profile')) browser.setAttribute('fireform_prof',p.getAttribute('profile'));
      if (p.hasAttribute('strictmatch')) browser.setAttribute('fireform_strictmatch',p.getAttribute('strictmatch'));
     }//else
   }

}//openfill

fireform.indirectList=function(requrl)
{

var doc=document.getElementById("fireform-strings");
var request = new XMLHttpRequest();
request.open("GET", requrl, true); 
request.onreadystatechange = 
 function (aEvt) {
  if (request.readyState == 4) {
     if(request.status == 200)
     { 
       if (requrl.indexOf("http://pastebin.ws")==0)
       { // retrieve content box
		var parser=new DOMParser();
		var resultDoc=parser.parseFromString(request.responseText,"text/xml");
		// test epic fail
		var resultTxt=resultDoc.getElementById("contentbox").value;
       }
       else
       {
       var resultTxt=request.responseText;
       }
     
       var parser = new DOMParser();
       var xmldoc = parser.parseFromString(resultTxt,"application/xml");
     
       var sublist=xmldoc.getElementsByTagName("list")[0];
       if (sublist)
          fireform.openfill(sublist);
     }  
     else
       alert("Error reading "+requrl);
  }//if
  }//function

request.send(null); 

}//indirectlist

fireform.autofill=function(event)
{ 

fireform.searchpassword=function(win)
{
var formElements = win.document.getElementsByTagName("input");
for (var i = 0; i < formElements.length; i++) 
   if (formElements[i].type=="password") return true; // password field

var frames = win.document.getElementsByTagName("frame");
for (var i = 0; i < frames.length; i++)
   if (fireform.searchpassword(frames[i])) return true;

var frames = win.document.getElementsByTagName("iframe");
for (var i = 0; i < frames.length; i++)
   if (fireform.searchpassword(frames[i])) return true;
   
return false;
}

   var doc = event.originalTarget;
   // make sure to get the top frame
   doc = doc.defaultView.top.document; 
   var browser = getBrowser().getBrowserForDocument(doc);
   if (browser.hasAttribute('fireform_wait')) 
     { var wait=parseInt(browser.getAttribute('fireform_wait'));
       if (wait!=0) { browser.setAttribute('fireform_wait',wait-1); return}
     } 
   if (browser.hasAttribute('fireform_waitonpassword')) 
     { // var wait=parseInt(browser.getAttribute('fireform_waitonpassword'));
       if (fireform.searchpassword(browser)) return;
     }  
        
   browser.removeEventListener("DOMContentLoaded", fireform.autofill, false);
   var myprof='';
   var strictmatch=false;
   if (browser.hasAttribute('fireform_prof')) myprof=browser.getAttribute('fireform_prof');
   if (browser.hasAttribute('fireform_strictmatch')) strictmatch=browser.getAttribute('fireform_strictmatch');
   fireform.FillFields(browser.contentWindow,0,myprof,true,strictmatch);
}

