/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * Licens.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// Is this a good example of using xml templates?

var fireform_siteslist={
    };

fireform_siteslist.loadlist=function()
{
if (fireform_prefs.prefHasUserValue("siteslist.xml")) var txt=fireform_prefs.getCharPref("siteslist.xml");
else var txt=fireform_getstring("siteslist-demo");

var parser = new DOMParser();
var xmldoc = parser.parseFromString(txt,"application/xml");

fireform_siteslist.display(xmldoc.firstChild)

}//loadlist()

fireform_siteslist.indirectList=function(root,requrl)
{
var doc=document.getElementById("fireform-strings");
var request = new XMLHttpRequest();
request.open("GET", requrl, true); 
request.onreadystatechange = 
 function (aEvt) {
  if (request.readyState == 4) {
     if(request.status == 200)
     { 
       if (requrl.indexOf("http://pastebin.ws")==0)
       { // retrieve content box
		var parser=new DOMParser();
		var resultDoc=parser.parseFromString(request.responseText,"text/xml");
		// test epic fail
		var resultTxt=resultDoc.getElementById("contentbox").value;
       }
       else
       {
       var resultTxt=request.responseText;
       }
     
       var parser = new DOMParser();
       var xmldoc = parser.parseFromString(resultTxt,"application/xml");
     
       var sublist=xmldoc.getElementsByTagName("list")[0];
       if (sublist)
       {    
         sublist.setAttribute("value", root.getAttribute("value"));
         sublist.setAttribute("desc", root.getAttribute("desc"));
         sublist.setAttribute("vdisabled", "true");
         root.parentNode.replaceChild(sublist,root);
     	}
       document.getElementById("fireform-siteslist-display").builder.rebuild();
     }  
     else
       alert("Error reading "+requrl);
  }//if
  }//function

request.send(null); 

}//indirectlist

fireform_siteslist.display=function(xml)
{

function recurseSite(root)
{
while (root)
{ 
 if (root.firstChild) recurseSite(root.firstChild);
 if (root.tagName=="site")
   {
   var myurl=root.getAttribute('value');
   if (myurl.substring(0,1)=='=') 
     fireform_siteslist.indirectList(root,myurl.substring(1));  
   } 
 root=root.nextSibling;  
}//while
}//recurse

var ds=document.getElementById("fireform-siteslist-datasource");
while (ds.firstChild) ds.removeChild(ds.firstChild); // remove previous display
ds.appendChild(xml);
document.getElementById("fireform-siteslist-display").builder.rebuild();
// look for indirection
recurseSite(ds);

}

fireform_siteslist.add_new_site=function(grid,url)
{
var r=document.getElementById("fireform-siteslist-row").cloneNode(true);r.setAttribute('id',"");
// any better way to clone?
var buts=r.getElementsByTagName("button");
for (var i=0;i < buts.length; i++) {buts[i].removeAttribute("disabled");}
var boxes=r.getElementsByTagName("textbox");
for (var i=0;i < boxes.length; i++) {boxes[i].setAttribute("value","");boxes[i].removeAttribute("disabled");}
if (url) boxes[0].setAttribute("value",url);
var chks=r.getElementsByTagName("checkbox");
for (var i=0;i < chks.length; i++) {chks[i].removeAttribute("checked");chks[i].removeAttribute("disabled");}
grid.getElementsByTagName("rows")[0].appendChild(r);
boxes[0].focus();
}

fireform_siteslist.addlist=function()
{
var doc=document.getElementById("fireform-strings");
// ask for name

var newlist = {value: ""};
var check = {value: false};

if (!fireform_prompts.prompt(window, doc.getString("create_sitelist_title"), doc.getString("ask_sitelist_name"), newlist, null, check)) return;

var l=document.createElementNS("","list");
l.setAttribute("name",newlist.value);l.setAttribute("focus",true);
var s=document.createElementNS("","site");
l.appendChild(s);
var xml=fireform_siteslist.inputtoxml(false);
xml.appendChild(l);
fireform_siteslist.display(xml);
}//addlist

fireform_siteslist.dellist=function()
{
var tabs=document.getElementById("fireform-siteslist-display").getElementsByTagName("tabs")[1];
var tps=document.getElementById("fireform-siteslist-display").getElementsByTagName("tabpanels")[1];
var tb=tabs.firstChild;
var tp=tps.firstChild;
while (tb)
{ 
 if (tb.selected) 
  {   var newtb=tb.nextSibling;if (!newtb) newtb=tb.previousSibling;if (newtb) newtb.click();
      tabs.removeChild(tb);tps.removeChild(tp);break;
  }
tb=tb.nextSibling;
tp=tp.nextSibling;
}//while

}//dellist


fireform_siteslist.inputtoxml=function(setfocus)
{

var root=document.getElementsByTagName("tabbox");

for (var i = 1; i < root.length; i++) //avoid template
{
  var siteslist=document.createElementNS("","fireform_siteslist");
  var tabs=root[i].getElementsByTagName("tab");
  var tps=root[i].getElementsByTagName("tabpanel");
  for (var j = 0; j < tps.length; j++)
  { var list=document.createElementNS("","list");
     list.setAttribute("name",tabs[j].getAttribute("label"));
     var curfoc=false;
     if (setfocus)
       if (tabs[j].selected) {list.setAttribute("focus",true);curfoc=true;}
     var rows=tps[j].getElementsByTagName("row");
     var disable=false;   
     var tabsite=new Array();
     for (var k = 1; k < rows.length; k++) //avoid labels
     { 
       var r=rows[k].firstChild;
       if ((r) && (r.getAttribute("disabled"))) continue;
       var site=document.createElementNS("","site");
       while(r)
       { 
         var name=r.getAttribute("name")
         var val=r.value;
         var chk=r.getAttribute("checked");
         
        switch(name) {
        case "url":
           site.setAttribute("value",val);
           break;
        case "profile":
        case "desc":
        case "wait":
           if (val!="") site.setAttribute(name,val);
           break;
        case "waitonpwd":   
        case "strictmatch":  
           if (chk=="true") site.setAttribute(name,true);
           break;
          }//case
       r=r.nextSibling;
       }    
    // list.appendChild(site);
       tabsite.push(site);
     }
     // to be done : array sort?
     for each (s in tabsite)
		list.appendChild(s)

     siteslist.appendChild(list);
  }
 }
return siteslist;
} //inputtoxml

fireform_siteslist.exportlist=function()
{
var doc =document.getElementById("fireform-strings");

var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("exportfile"), nsIFilePicker.modeSave);
fp.appendFilters(nsIFilePicker.filterXML,"xml","xml");
//fp.appendFilter("fireform profiles (xml)","*.xml");
fp.defaultExtension="xml";
fp.defaultString=".xml";
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
foStream.init(fp.file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate

var xml=fireform_siteslist.inputtoxml(true);
var xmldoc = document.implementation.createDocument("", "", null);
xmldoc.async = false; 
xmldoc.appendChild(xml);

var xmls = new XMLSerializer();
xmls.serializeToStream(xmldoc,foStream,"UTF-8");
foStream.close();

var msg=new Array();msg[0]=xml.childNodes.length;
fireform_alert(doc.getFormattedString("siteslistsexported",msg));  

}//export

fireform_siteslist.importlist=function()
{
var doc =document.getElementById("fireform-strings");
var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("importfile"), nsIFilePicker.modeOpen);
fp.appendFilters(nsIFilePicker.filterXML);

//fp.appendFilter("fireform profiles (xml)","*.xml");
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var fistream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
fistream.init(fp.file, -1, 0, 0);

var parser = new DOMParser();
var xmldoc = parser.parseFromStream(fistream, 0 , 1000000, "text/xml");
fistream.close();
var xml=fireform_siteslist.inputtoxml(true);
var newlist=xmldoc.firstChild.firstChild;
while(newlist)
{
xml.appendChild(newlist.cloneNode(true)); // add to current list
newlist=newlist.nextSibling;
}

fireform_siteslist.display(xml);
var msg=new Array();msg[0]=xmldoc.firstChild.childNodes.length;
fireform_alert(doc.getFormattedString("siteslistsimported",msg));  
} //import

fireform_siteslist.openlist=function(all)
{
var list=fireform_siteslist.inputtoxml(true);
if (!all)
 {var tps=document.getElementById("fireform-siteslist-display").getElementsByTagName("tabpanels")[1];
  list=list.childNodes[tps.selectedIndex];
 }
window.opener.fireform.openfill(list);
}

fireform_siteslist.savelist=function()
{
var xml=fireform_siteslist.inputtoxml(true);
var xmldoc = document.implementation.createDocument("", "", null);
xmldoc.async = false; 
xmldoc.appendChild(xml);

var xmls = new XMLSerializer();
var txt=xmls.serializeToString(xmldoc);

fireform_prefs.deleteBranch("siteslist");
fireform_prefs.setCharPref("siteslist.xml",txt);

}//savelist

fireform_siteslist.move=function(thisrow,direction)
{
var parent=thisrow.parentNode;
for each (tb in thisrow.getElementsByTagName("textbox")) //keep updated inputs
  if (tb.value) {
    var attv=document.createAttribute("value");
    attv.value=tb.value;
    tb.setAttributeNode(attv);
  }  
  
if (direction)// up
{
  var prev=thisrow.previousSibling;
  if (!prev.previousSibling) return; //firstline
  parent.insertBefore(thisrow,prev);
}
else // down
{
  var next=thisrow.nextSibling;
  if (next) //avoid lastline
  parent.insertBefore(thisrow,next.nextSibling); //works even when null
}

}//move